// Generated by CoffeeScript 1.8.0
(function() {
  var digit, mask, normalize, typeNames, _;

  _ = require('lodash');

  typeNames = ['credential', 'date', 'email', 'phone', 'postal_code', 'range', 'ssn', 'time'];

  module.exports = {};

  module.exports.names = typeNames;

  typeNames.forEach(function(name) {
    return module.exports[name] = require("./" + (name.replace('_', '-')));
  });

  digit = /^\d+$/;

  module.exports.normalize = normalize = function(obj) {
    var extendedKeys, key, str, value, _i, _len;
    if (obj == null) {
      return obj;
    }
    if (obj instanceof String || obj instanceof Boolean || obj instanceof Number) {
      extendedKeys = Object.keys(obj).filter(function(key) {
        return !key.match(digit);
      });
      if (extendedKeys.length) {
        str = {
          normal: obj.valueOf()
        };
        for (_i = 0, _len = extendedKeys.length; _i < _len; _i++) {
          key = extendedKeys[_i];
          str[key] = normalize(obj[key]);
        }
        obj = str;
      } else {
        obj = obj.valueOf();
      }
    } else if (obj instanceof Array) {
      obj = obj.map(function(i) {
        return normalize(i);
      });
    } else if (typeof obj === 'object') {
      for (key in obj) {
        value = obj[key];
        obj[key] = normalize(value);
      }
    }
    return obj;
  };

  module.exports.parse = function(name, value, req) {
    var type, _ref;
    if (typeNames.indexOf(name) !== -1) {
      type = module.exports[name];
    }
    if ((type != null) && (value != null)) {
      if (((_ref = type.components) != null ? _ref.length : void 0) && (value.valid != null)) {
        return value;
      } else {
        return type.parse(value, req);
      }
    } else {
      return value;
    }
  };

  module.exports.mask = mask = function(obj, doMask) {
    var key, str, value;
    if (doMask == null) {
      doMask = false;
    }
    if (obj == null) {
      return obj;
    }
    if (obj instanceof Array) {
      obj = obj.map(function(i) {
        return mask(i, doMask);
      });
    } else if (typeof obj === 'object') {
      if (obj.masked === false && (obj instanceof String || obj instanceof Boolean || obj instanceof Number)) {
        str = new String(mask(obj.toString(), true));
        for (key in obj) {
          value = obj[key];
          if (key === 'valid') {
            continue;
          }
          if (!key.match(digit)) {
            str[key] = mask(value, true);
          }
        }
        str.masked = true;
        obj = str;
      } else {
        for (key in obj) {
          value = obj[key];
          if (key === 'valid') {
            continue;
          }
          obj[key] = mask(value, (obj.masked != null) || doMask);
        }
        if (obj.masked != null) {
          obj.masked = true;
        }
      }
    } else if (_.isString(obj) || _.isNumber(obj)) {
      if (doMask) {
        obj = obj.toString().replace(/./g, '*');
      }
    } else if (_.isBoolean(obj)) {
      if (doMask) {
        obj = '*';
      }
    } else {
      throw "Don't know how to mask " + obj;
    }
    return obj;
  };

  module.exports.isValid = function(value) {
    if (!_.isPlainObject(value)) {
      return true;
    }
  };

}).call(this);
