// Generated by CoffeeScript 1.8.0
(function() {
  var components, minRegex, named, parse, rangeRegex, _;

  _ = require('lodash');

  named = require('named-regexp').named;

  minRegex = named(/(:<min>\d+)\s*\+/);

  rangeRegex = named(/(:<min>\d+)\s*(?:\-|to|\s+)\s*(:<max>\d+)/);

  parse = function(string) {
    var captures, match, max, min, num, parsed, _ref, _ref1;
    if (string == null) {
      return string;
    }
    match = minRegex.exec(string) || rangeRegex.exec(string);
    if (match) {
      captures = match.captures;
      min = (((_ref = captures.min) != null ? _ref[0] : void 0) != null) && parseFloat(captures.min[0]);
      max = (((_ref1 = captures.max) != null ? _ref1[0] : void 0) != null) && parseFloat(captures.max[0]);
      if (_(min).isNumber() && _(max).isNumber()) {
        parsed = new String("" + min + "-" + max);
        parsed.raw = string;
        parsed.avg = (min + max) / 2;
        parsed.min = min;
        parsed.max = max;
      } else if (_(min).isNumber()) {
        parsed = new String("" + min + "+");
        parsed.raw = string;
        parsed.avg = null;
        parsed.min = min;
        parsed.max = null;
      } else {
        parsed = new String(string);
        parsed.raw = string;
        parsed.valid = false;
      }
    } else {
      num = parseFloat(string);
      if (isNaN(num)) {
        num = null;
      }
      parsed = new String(string);
      parsed.raw = string;
      parsed.min = num;
      parsed.max = num;
      parsed.avg = num;
      parsed.valid = !isNaN(num);
    }
    if (parsed.valid == null) {
      parsed.valid = true;
    }
    return parsed;
  };

  components = [
    {
      name: 'raw',
      type: 'string',
      description: 'Unmodified value'
    }, {
      name: 'normal',
      type: 'number',
      description: 'Average of max and min, rounded down to the nearest integer'
    }, {
      name: 'max',
      type: 'number',
      description: 'Range maximum'
    }, {
      name: 'min',
      type: 'number',
      description: 'Range minimum'
    }, {
      name: 'avg',
      type: 'number',
      description: 'Range average'
    }
  ];

  module.exports = {
    parse: parse,
    components: components,
    maskable: false
  };

}).call(this);
